﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Data;
using SuperMap.Desktop;
using SuperMap.Realspace;
using SuperMap.Data;
using System.Drawing ;


namespace SuperMap.Desktop.CloudTrack
{
    class _CtrlActionStartTrack:CtrlAction 
    {
        static public  Timer timer = new Timer(); //Define timer

        int m_index;
        int m_indexpre;
        int featuresCount;

        Layer3Ds m_layer3ds;
        Layer3D m_layer3d;

        int m_Count = 1;
        public _CtrlActionStartTrack(IBaseItem caller)
            : base(caller)
        {
          timer.Tick  += new EventHandler(TimerTickhandler);
          timer.Interval = 1000;
        }
        
        public void TimerTickhandler(object sender,EventArgs e)
        {

            ShowPng(1);
        }

        public override void Run()
        {
            try
            {
                if (m_Count == 1)
                {

                    IFormScene MainScene = Application.ActiveForm as IFormScene;
                    Scene scene = MainScene.SceneControl.Scene;
                    //Add KML file
                    OpenFileDialog openfileDlg = new OpenFileDialog();
                    openfileDlg.Title = "Add KML File";
                    openfileDlg.Filter = "KML Fiels (*.kml)|*.kml";
                    openfileDlg.FileName = "";
                    openfileDlg.ShowDialog();
                    string strKML = string.Empty;
                    strKML = openfileDlg.FileName;
                    if (strKML == "")
                    {
                        MessageBox.Show("Please select a KML file!");
                        return;
                    }
                    else
                    {
                        //Point camera to China

                        Camera camera = new Camera();
                        camera.Altitude = 6378000;
                        camera.AltitudeMode = AltitudeMode.RelativeToGround;
                        camera.Latitude = 36;
                        camera.Longitude = 117;
                        scene.Fly(camera);

                        m_layer3ds = scene.Layers;
                        m_layer3d = m_layer3ds.Add(strKML, Layer3DType.KML, true);
                        Feature3Ds feature3Ds = m_layer3d.Features;
                        featuresCount = feature3Ds.Count;
                        if (featuresCount == 0)
                        {
                            MessageBox.Show("Add KML file failed!");
                        }
                        else
                        {
                            m_index = 0;
                            timer.Enabled = true;
                        }
                    }
                    m_Count++;
                }
                else if (m_Count >1)
                {
                    timer.Enabled = true;
                }
            }
            catch (Exception ex)
            {
                Application.ActiveApplication.Output.Output(ex.Message);
            }
       
        }
        //Adjust the display ID
        void AdjustIndex(int Sign)
        {
            m_indexpre = m_index;
            m_index += Sign;

            if (m_index == featuresCount)
            {
                timer.Enabled = false;
                DialogResult dialogResult = MessageBox.Show("Do you want to start another circle?", 
                    "Prompt", MessageBoxButtons.YesNo);
                if (dialogResult==DialogResult.Yes )
                {
                    m_index = 0;
                    timer.Enabled = true;
                }
                else if (dialogResult==DialogResult.No )
                {
                    timer.Enabled = false;
                    //Set the first element to display on the scene when loading stopped

                    Sign =0;
                    m_index = 0;
                }
            }
            if (m_index < 0)
            {
                m_index = featuresCount - 1;
            }
        }
        void ShowPng(int Sign)
        {
            AdjustIndex(Sign );

            Feature3D feature3d = m_layer3d.Features[m_indexpre] as Feature3D;
            feature3d.IsVisible = false;
            feature3d = m_layer3d.Features[m_index] as Feature3D;
            feature3d.IsVisible = true;
        }
    }
}
